      function ACCUTE_I(x1,y1,x2,y2,x3,y3,iedge,par)
c     ... compute the inner angles of a triangle [x1,y1], [x2,y2], [x3,y3]
c     ... and return 1 + \sum_{j=1}^3 ( (\cos a_i)^-)^2
      real*8 x(3),y(3),vax,vay,vbx,vby,ccos,ang

      ACCUTE_I = 1.
      x(1) = x1
      x(2) = x2
      x(3) = x3
      y(1) = y1
      y(2) = y2
      y(3) = y3

c      print*,x(1),y(1)
c      print*,x(2),y(2)
c      print*,x(3),y(3)

      j0 = mod(iedge,3) + 1
      j1 = mod(j0,3) + 1
      j2 = mod(j1,3) + 1
      vax = x(j0) - x(j1)
      vay = y(j0) - y(j1)
      vbx = x(j2) - x(j1)
      vby = y(j2) - y(j1)
      ccos = (vax*vbx + vay*vby)
      if(ccos .lt. 0.D+0) then
         ang = ccos*ccos/(vax*vax + vay*vay)/(vbx*vbx + vby*vby)
         ACCUTE_I = ACCUTE_I+12.*par*ang
      endif
c     print*
c     print*,vax,vay
c     print*,vbx,vby
c     print*, ccos,ang
c     print*,'--------------------'

c      print*,'ACCUTE_I = ',ACCUTE_I
c      print*,'***************************************'
      return 
      end

      function ACCUTE(x1,y1,x2,y2,x3,y3,par)
c     ... compute the inner angles of a triangle [x1,y1], [x2,y2], [x3,y3]
c     ... and return 1 + \sum_{j=1}^3 ( (\cos a_i)^-)^2
      real*8 x(3),y(3),vax,vay,vbx,vby,ccos,ang

      ACCUTE = 1.
      x(1) = x1
      x(2) = x2
      x(3) = x3
      y(1) = y1
      y(2) = y2
      y(3) = y3

c      print*,x(1),y(1)
c      print*,x(2),y(2)
c      print*,x(3),y(3)

      do j0=1,3
         j1 = mod(j0,3) + 1
         j2 = mod(j1,3) + 1
         vax = x(j0) - x(j1)
         vay = y(j0) - y(j1)
         vbx = x(j2) - x(j1)
         vby = y(j2) - y(j1)
         ccos = (vax*vbx + vay*vby)
         if(ccos .lt. 0.D+0) then
            ang = ccos*ccos/(vax*vax + vay*vay)/(vbx*vbx + vby*vby)
            ACCUTE = ACCUTE+12.*par*ang
         endif
c         print*
c         print*,vax,vay
c         print*,vbx,vby
c         print*, ccos,ang
c         print*,'--------------------'
      enddo
c      print*,'ACCUTE = ',ACCUTE
c      print*,'***************************************'
      return 
      end

      subroutine DELAUNAY(ndim, melem,nelem,mpoin,npoin,
     *     x,y,lnd,iae,icha,
     *     ra,wp,rga,rgb,rgc,iba,nbelm,mbelm,lbn,ibc,itc,
     *     maxdeg,icyc,ibp)
      dimension lnd(melem,3),iae(melem,3),x(mpoin),y(mpoin),
     *     lbn(mbelm,2),ibc(mbelm),itc(mbelm),
     *     ra(melem*3),wp(mpoin,ndim+1), 
     *     icyc(mpoin,maxdeg),ibp(mpoin,2),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin)
      integer iba(melem,3)
      real *8 x1,y1,x2,y2,x3,y3,x4,y4,reps123,reps134,det123,det134,
     *     detdel, z1, z2, z3, z4

      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4

      icha = 0
c      return

      do i=1,nelem
         do j=1,3
            iba(i,j) = 0
         enddo
      enddo

      itest = -1499

      ice = 0
      do 10 i=1,nelem
         do 20 j=1,3
            if(iae(i,j) .gt. 0 .and. iba(i,j) .eq. 0) then
               j1 = mod(j,3) +1
               j2 = mod(j1,3) +1
               ii = iae(i,j)

               do 30 jjj=1,3
                  if(lnd(ii,jjj) .eq. lnd(i,j1)) jj = jjj
 30            continue
               iba(i,j) = 1
               iba(ii,jj) = 1
               jj1 = mod(jj,3) +1
               j0 = mod(jj1,3) +1
               k1 = lnd(i,j2)
               k2 = lnd(i,j)
               k3 = lnd(ii,j0)
               k4 = lnd(i,j1)
               if( k2 .ne. lnd(ii,jj1) .or. k4 .ne. lnd(ii,jj) ) then
                  print *,'ERROR !@#'
                  print *,k1,k2,k3,k4
                  return
               endif
               x1 = x(k1)
               y1 = y(k1)
               x2 = x(k2)
               y2 = y(k2)
               x3 = x(k3)
               y3 = y(k3)
               x4 = x(k4)
               y4 = y(k4)

               if( i .eq. itest) then
c                  print *,x(lnd(i,j)),y(lnd(i,j)),j,ii,iba(i,j)
c                  print *,x(lnd(i,j1)),y(lnd(i,j1))
c                  print *,x(lnd(i,j2)),y(lnd(i,j2))
                  print *
                  print *,x1,y1
                  print *,x2,y2
                  print *,x3,y3
                  print *,x4,y4
               endif

c     we prohibid SWAPPING in case, where can appear alement with two
c     boundary segment
               if( (iae(i,j2) .lt. 0 .and. iae(ii,jj1) .lt. 0 ) .or.
     *              (iae(i,j1) .lt. 0 .and. iae(ii,j0) .lt. 0) ) then
                  goto 20
               endif
c     we must still chech the orientation, i.e. the  cykles of points
c     k1,k2,k4 and k1,k4,k3 must have positive orientation

               det123 = x1*(y2-y3) + x2*(y3-y1) + x3*(y1-y2)
               det134 = x1*(y3-y4) + x3*(y4-y1) + x4*(y1-y3) 

               reps123 = pos*( ((x1-x3)**2 + (y1-y3)**2) +
     *              ((x2-x3)**2 + (y2-y3)**2) +
     *              ((x1-x2)**2 + (y1-y2)**2) )
               reps134 = pos*( ((x1-x3)**2 + (y1-y3)**2) +
     *              ((x4-x3)**2 + (y4-y3)**2) +
     *              ((x1-x4)**2 + (y1-y4)**2) )
               if( det123 .le. reps123 .or. det134 .le. reps134) then
c                  print *,'violation of positivity-1'
                  goto 20
               endif
               call POS1TEST(x(k1),y(k1),x(k2),y(k2),x(k3),y(k3),itet)
               if(itet .eq. 1) then
c                  print *,'violation of positivity-2'
                  goto 20
               endif
               call POS1TEST(x(k1),y(k1),x(k3),y(k3),x(k4),y(k4),itet)
               if(itet .eq. 1) then
c                  print *,'violation of positivity-3'
                  goto 20
               endif


               z1 = x1*x1 + y1*y1
               z2 = x2*x2 + y2*y2
               z3 = x3*x3 + y3*y3
               z4 = x4*x4 + y4*y4

               detdel = (x1*(y2*z3-y3*z2) - x2*(y1*z3-y3*z1) +
     *              x3*(y1*z2-y2*z1)) 
     *              -  (x1*(y2*z4-y4*z2) - x2*(y1*z4-y4*z1) +
     *              x4*(y1*z2-y2*z1)) 
     *              +  (x1*(y3*z4-y4*z3) - x3*(y1*z4-y4*z1) +
     *              x4*(y1*z3-y3*z1)) 
     *              -  (x2*(y3*z4-y4*z3) - x3*(y2*z4-y4*z2) +
     *              x4*(y2*z3-y3*z2)) 

               if( i .eq. itest) print *, detdel

c               if(detdel .lt. -1E-05) then
               if(detdel .lt. -1.D-12) then


c                  print *,x1,y1,detdel
c                  print *,x2,y2
c                  print *,x3,y3
c                  print *,x4,y4
c                  call PLOT(melem,nelem,mpoin,npoin,x,y,lnd)
c
c                  stop


c     we swap the diagonal
                  itci = 0
                  itcii = 0

                  iyii = iae(ii,jj1)
                  if(iyii .gt. 0) then
                     do 62 iy=1,3
                        if( iae(iyii,iy) .eq. ii) then
                           iyiij = iy
                        endif
 62                  continue
                  else
c     boundary segment, we seek itc
                     do ib1 =1,nbelm
                        if(itc(ib1) .eq. ii) then
                           itci = ib1
                           goto 662
                        endif
                     enddo
                     print *,'boundary segment in DELANAY for itc not'
                     stop
                  endif
 662              continue

                  iyi = iae(i,j1)
                  if(iyi .gt. 0) then
                     do 63 iy=1,3
                        if( iae(iyi,iy) .eq. i) then
                           iyij = iy
                        endif
 63                  continue
                  else
                     do ib1 =1,nbelm
                        if(itc(ib1) .eq. i) then
                           itcii = ib1
                           goto 663
                        endif
                     enddo
                     print *,'boundary segment in DELANAY for itc not2'
                     stop
                  endif
 663              continue
                  if(itci .gt. 0) itc(itci) = i
                  if(itcii .gt. 0) itc(itcii) = ii
                  
                  lnd(i,j1) = k3
                  lnd(ii,jj1) = k1
                  
                  iae(i,j) = iyii
                  iae(i,j1) = ii
                  if(iyii .gt.0 ) iae(iyii,iyiij) = i

                  iae(ii,jj) = iyi
                  iae(ii,jj1) = i
                  if(iyi .gt.0 ) iae(iyi,iyij) = ii

                  icha = icha+1
               endif
            endif
 20      continue
 10   continue
      return
      end



      subroutine SWAPPING(ndim, melem,nelem,mpoin,npoin,
     *     x,y,lnd,iae,icha,
     *     ra,wp,rga,rgb,rgc,iba,nbelm,mbelm,lbn,ibc,itc,
     *     maxdeg,icyc,ibp)
      dimension lnd(melem,3),iae(melem,3),x(mpoin),y(mpoin),
     *     lbn(mbelm,2),ibc(mbelm),itc(mbelm),
     *     ra(melem*3),wp(mpoin,ndim+1), 
     *     icyc(mpoin,maxdeg),ibp(mpoin,2),
     *     rga(mpoin),rgb(mpoin),rgc(mpoin)
      integer iba(melem,3)
      real *8 x1,y1,x2,y2,x3,y3,x4,y4,reps123,reps134,det123,det134

      common /const/ p, epsilon1, pos, pos1, numel,ityp
      common /period/ xper,yper,iper1,iper2
      common /period2/ xper2,yper2,iper3,iper4

      do i=1,nelem
         do j=1,3
            iba(i,j) = 0
         enddo
      enddo

      ice = 0
      icha = 0
      do 10 i=1,nelem
         do 20 j=1,3
            if(iae(i,j) .gt. 0 .and. iba(i,j) .eq. 0) then
               j1 = mod(j,3) +1
               j2 = mod(j1,3) +1
               ii = iae(i,j)
               do 30 jjj=1,3
                  if(lnd(ii,jjj) .eq. lnd(i,j1)) jj = jjj
 30            continue
               iba(i,j) = 1
               iba(ii,jj) = 1
               jj1 = mod(jj,3) +1
               j0 = mod(jj1,3) +1
               k1 = lnd(i,j2)
               k2 = lnd(i,j)
               k3 = lnd(ii,j0)
               k4 = lnd(i,j1)
               if( k2 .ne. lnd(ii,jj1) .or. k4 .ne. lnd(ii,jj) ) then
                  print *,'ERROR !@#'
                  print *,k1,k2,k3,k4
                  return
               endif
               x1 = x(k1)
               y1 = y(k1)
               x2 = x(k2)
               y2 = y(k2)
               x3 = x(k3)
               y3 = y(k3)
               x4 = x(k4)
               y4 = y(k4)
               w1 = wp(k1,1)
               w2 = wp(k2,1)
               w3 = wp(k3,1)
               w4 = wp(k4,1)

c     we prohibid SWAPPING in case, where can appear alement with two
c     boundary segment
               if( (iae(i,j2) .lt. 0 .and. iae(ii,jj1) .lt. 0 ) .or.
     *              (iae(i,j1) .lt. 0 .and. iae(ii,j0) .lt. 0) ) then
                  goto 20
               endif
c     we must still chech the orientation, i.e. the  cykles of points
c     k1,k2,k4 and k1,k4,k3 must have positive orientation

               det123 = x1*(y2-y3) + x2*(y3-y1) + x3*(y1-y2)
               det134 = x1*(y3-y4) + x3*(y4-y1) + x4*(y1-y3) 

               reps123 = pos*( ((x1-x3)**2 + (y1-y3)**2) +
     *              ((x2-x3)**2 + (y2-y3)**2) +
     *              ((x1-x2)**2 + (y1-y2)**2) )
               reps134 = pos*( ((x1-x3)**2 + (y1-y3)**2) +
     *              ((x4-x3)**2 + (y4-y3)**2) +
     *              ((x1-x4)**2 + (y1-y4)**2) )
               if( det123 .le. reps123 .or. det134 .le. reps134) then
c                  print *,'violation of positivity'
                  goto 20
               endif

               itet = 0
               call POS1TEST(x(k1),y(k1),x(k2),y(k2),x(k3),y(k3),itet)
               if(itet .eq. 1) then
                  goto 20
               endif
               call POS1TEST(x(k1),y(k1),x(k3),y(k3),x(k4),y(k4),itet)
               if(itet .eq. 1) then
                  goto 20
               endif

               acc_old = ACCUTE(x(k1),y(k1),x(k2),y(k2),x(k4),y(k4),1.)
     *              *ACCUTE(x(k2),y(k2),x(k3),y(k3),x(k4),y(k4),1. )

               acc_new = ACCUTE(x(k1),y(k1),x(k2),y(k2),x(k3),y(k3),1. )
     *              *ACCUTE(x(k1),y(k1),x(k3),y(k3),x(k4),y(k4),1. )
               ice = 0

               epsround = 5E-03

               rl13 = ( (rga(k1)+rga(k3))*(x1-x3)*(x1-x3) +
     *              2*(rgb(k1)+rgb(k3))*(x1-x3)*(y1-y3)  +
     *              (rgc(k1)+rgc(k3))*(y1-y3)*(y1-y3) )/2

               rl24 = ( (rga(k2)+rga(k4))*(x2-x4)*(x2-x4) +
     *              2*(rgb(k2)+rgb(k4))*(x2-x4)*(y2-y4)  +
     *              (rgc(k2)+rgc(k4))*(y2-y4)*(y2-y4) )/2


c               if(abs(rl13 - 3.) .lt. 0.995 * abs(rl24 -3.) )then
c     ... NEW ACCUTE
               if(abs(rl13 - 3.)*acc_new .lt. 
     *              0.995 * abs(rl24 -3.)*acc_old )then

c        ... we use a SWAPPING
                  itci = 0
                  itcii = 0

                  iyii = iae(ii,jj1)
                  if(iyii .gt. 0) then
                     do 62 iy=1,3
                        if( iae(iyii,iy) .eq. ii) then
                           iyiij = iy
                        endif
 62                  continue
                  else
c     boundary segment, we seek itc
                     do ib1 =1,nbelm
                        if(itc(ib1) .eq. ii) then
                           itci = ib1
                           goto 662
                        endif
                     enddo
                     print *,'boundary segment in SWAPPING for itc not'
                     stop
                  endif
 662              continue

                  iyi = iae(i,j1)
                  if(iyi .gt. 0) then
                     do 63 iy=1,3
                        if( iae(iyi,iy) .eq. i) then
                           iyij = iy
                        endif
 63                  continue
                  else
                     do ib1 =1,nbelm
                        if(itc(ib1) .eq. i) then
                           itcii = ib1
                           goto 663
                        endif
                     enddo
                     print *,'boundary segment in SWAPPING for itc not2'
                     stop
                  endif
 663              continue
                  if(itci .gt. 0) itc(itci) = i
                  if(itcii .gt. 0) itc(itcii) = ii
                  
                  lnd(i,j1) = k3
                  lnd(ii,jj1) = k1
                  
                  iae(i,j) = iyii
                  iae(i,j1) = ii
                  if(iyii .gt.0 ) iae(iyii,iyiij) = i

                  iae(ii,jj) = iyi
                  iae(ii,jj1) = i
                  if(iyi .gt.0 ) iae(iyi,iyij) = ii
                  icha = icha+1
               endif
            endif
 20      continue
 10   continue

      return
      end

